// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef M6502_HH
#define M6502_HH

#include <stdint.h>
#include <systemc>

class m6502 :
    public sc_core::sc_module
{

public:

    sc_core::sc_in< bool > clk;
    sc_core::sc_out< uint16_t > addr;
    sc_core::sc_in< uint8_t > datai;
    sc_core::sc_out< uint8_t > datao;
    sc_core::sc_in< bool > irq_n;
    sc_core::sc_in< bool > nmi_n;
    sc_core::sc_in< bool > sob_n;
    sc_core::sc_in< bool > res_n;
    sc_core::sc_in< bool > rdy;
    sc_core::sc_out< bool > vpab;
    sc_core::sc_out< bool > sync;
    sc_core::sc_out< bool > we_n;
    sc_core::sc_out< bool > oeb;

    uint8_t hif_cone_when();

    sc_core::sc_signal< bool > core_sm_psrl_7;
    sc_core::sc_signal< bool > core_sm_psrl_6;
    sc_core::sc_signal< bool > core_sm_psrl_5;
    sc_core::sc_signal< bool > core_sm_psrl_4;
    sc_core::sc_signal< bool > core_sm_psrl_3;
    sc_core::sc_signal< bool > core_sm_psrl_2;
    sc_core::sc_signal< bool > core_sm_psrl_1;
    sc_core::sc_signal< bool > core_sm_psrl_0;
    bool core_alu_dcd_7;
    bool core_alu_dcd_6;
    bool core_alu_dcd_5;
    bool core_alu_dcd_4;
    bool core_alu_dcd_3;
    bool core_alu_dcd_2;
    bool core_alu_dcd_1;
    bool core_alu_dcd_0;
    bool core_alu_bcd_out_7;
    bool core_alu_bcd_out_6;
    bool core_alu_bcd_out_5;
    bool core_alu_bcd_out_4;
    bool core_alu_bcd_out_3;
    bool core_alu_bcd_out_2;
    bool core_alu_bcd_out_1;
    bool core_alu_bcd_out_0;
    bool core_alu_add_out_7;
    bool core_alu_add_out_6;
    bool core_alu_add_out_5;
    bool core_alu_add_out_4;
    bool core_alu_add_out_3;
    bool core_alu_add_out_2;
    bool core_alu_add_out_1;
    bool core_alu_add_out_0;
    bool core_adhmx_pre_y_7;
    bool core_adhmx_pre_y_6;
    bool core_adhmx_pre_y_5;
    bool core_adhmx_pre_y_4;
    bool core_adhmx_pre_y_3;
    bool core_adhmx_pre_y_2;
    bool core_adhmx_pre_y_1;
    bool core_adhmx_pre_y_0;
    bool we_n_out_sig;
    bool vpa;
    bool oen;
    uint8_t core_addrh;
    uint8_t core_addrl;
    sc_core::sc_signal< uint8_t > core_dataol;
    uint8_t core_xregl;
    uint8_t core_yregl;
    uint8_t core_sregl;
    uint8_t core_aregl;
    uint8_t core_dregl;
    uint8_t core_alu_outl;
    uint8_t core_pchl;
    uint8_t core_pcll;
    uint8_t core_psrl;
    sc_core::sc_signal< uint16_t > core_alu_ctl;
    uint8_t core_alu2op;
    uint8_t core_alu_ld;
    uint8_t core_rg_load;
    bool core_sreg_up;
    bool core_sreg_cen;
    uint8_t core_pc_ctl;
    uint8_t core_adl_sel;
    uint8_t core_adh_sel;
    uint8_t core_domux_sel;
    bool core_reset;
    bool core_adhmx_pre_y_partial7;
    bool core_adhmx_pre_y_partial6;
    bool core_adhmx_pre_y_partial5;
    bool core_adhmx_pre_y_partial4;
    bool core_adhmx_pre_y_partial3;
    bool core_adhmx_pre_y_partial2;
    bool core_adhmx_pre_y_partial1;
    bool core_adhmx_pre_y_partial0;
    sc_core::sc_signal< uint8_t > core_arg_ido;
    sc_core::sc_signal< uint8_t > core_xrg_ido;
    sc_core::sc_signal< uint8_t > core_yrg_ido;
    uint8_t core_pc_cntih;
    uint8_t core_pc_cntil;
    sc_core::sc_signal< uint8_t > core_pc_hreg;
    uint8_t core_pc_hreg_in;
    sc_core::sc_signal< uint16_t > core_pc_pc;
    sc_core::sc_signal< uint8_t > core_drg_ido;
    uint8_t core_drg_idi;
    bool core_drg_ld;
    sc_core::sc_signal< uint8_t > core_srg_dataol;
    uint8_t core_adlmx_lreg;
    sc_core::sc_signal< uint8_t > core_adlmx_lrg_ido;
    uint8_t core_alu_jreg;
    uint8_t core_alu_kreg;
    uint8_t core_alu_add_b;
    uint8_t core_alu_log_b_preinv;
    uint8_t core_alu_log_b;
    uint8_t core_alu_log_out;
    bool core_alu_dcd_partial7;
    bool core_alu_dcd_partial6;
    bool core_alu_dcd_partial5;
    bool core_alu_dcd_partial4;
    bool core_alu_dcd_partial3;
    bool core_alu_dcd_partial2;
    bool core_alu_dcd_partial1;
    bool core_alu_dcd_partial0;
    uint8_t core_alu_log_ctl;
    uint8_t core_alu_alu_outl;
    bool core_alu_add_sub;
    bool core_alu_add_cin;
    bool core_alu_add_cout4;
    bool core_alu_add_cout;
    bool core_alu_alu_cout;
    bool core_alu_log_cin;
    bool core_alu_log_cout;
    bool core_alu_bcd_en;
    bool core_alu_bcd_cout;
    uint8_t core_alu_sign_ext;
    bool core_alu_z_flag;
    bool core_alu_n_flag;
    bool core_alu_v_flag;
    bool core_alu_bra_carry;
    uint8_t core_alu_adder_b_sub;
    uint8_t core_alu_adder_sub_v;
    bool core_alu_adder_cout4l;
    bool core_alu_adder_addh_sum_partial3;
    bool core_alu_adder_addh_sum_partial2;
    bool core_alu_adder_addh_sum_partial1;
    bool core_alu_adder_addh_sum_partial0;
    bool core_alu_adder_addh_cry_partial3;
    bool core_alu_adder_addh_cry_partial2;
    bool core_alu_adder_addh_cry_partial1;
    bool core_alu_adder_addh_cry_partial0;
    bool core_alu_adder_addl_sum_partial3;
    bool core_alu_adder_addl_sum_partial2;
    bool core_alu_adder_addl_sum_partial1;
    bool core_alu_adder_addl_sum_partial0;
    bool core_alu_adder_addl_cry_partial3;
    bool core_alu_adder_addl_cry_partial2;
    bool core_alu_adder_addl_cry_partial1;
    bool core_alu_adder_addl_cry_partial0;
    uint8_t core_alu_bcd_b_partial1;
    uint8_t core_alu_bcd_b_partial0;
    bool core_alu_bcd_cout4;
    bool core_alu_bcd_cin4l;
    bool core_alu_bcd_cout8;
    bool core_alu_bcd_gnd;
    bool core_alu_bcd_lo_adj;
    bool core_alu_bcd_hi_adj;
    bool core_alu_bcd_lo_adj_sub;
    bool core_alu_bcd_hi_adj_sub;
    bool core_alu_bcd_addh_sum_partial3_0;
    bool core_alu_bcd_addh_sum_partial2_0;
    bool core_alu_bcd_addh_sum_partial1_0;
    bool core_alu_bcd_addh_sum_partial0_0;
    bool core_alu_bcd_addh_cry_partial3_0;
    bool core_alu_bcd_addh_cry_partial2_0;
    bool core_alu_bcd_addh_cry_partial1_0;
    bool core_alu_bcd_addh_cry_partial0_0;
    bool core_alu_bcd_addl_sum_partial3_0;
    bool core_alu_bcd_addl_sum_partial2_0;
    bool core_alu_bcd_addl_sum_partial1_0;
    bool core_alu_bcd_addl_sum_partial0_0;
    bool core_alu_bcd_addl_cry_partial3_0;
    bool core_alu_bcd_addl_cry_partial2_0;
    bool core_alu_bcd_addl_cry_partial1_0;
    sc_core::sc_signal< bool > core_alu_bcd_addl_cry_partial0_0;
    sc_core::sc_signal< uint8_t > core_alu_krg_ido;
    sc_core::sc_signal< uint8_t > core_alu_jrg_ido;
    uint8_t core_alu_jrg_idi;
    bool core_alu_jrg_ld;
    uint8_t core_sm_opcode;
    uint8_t core_sm_opcode_in;
    bool core_sm_opcode_ld;
    uint8_t core_sm_state;
    uint8_t core_sm_state_in;
    bool core_sm_syncl;
    sc_core::sc_signal< bool > core_sm_wel_n;
    bool core_sm_we_d_n;
    bool core_sm_pc_load;
    bool core_sm_pc_h_load;
    bool core_sm_pc_cen;
    bool core_sm_pc_sel_datai;
    uint8_t core_sm_pc_vec_sel;
    bool core_sm_pcl_alu_ld;
    sc_core::sc_signal< bool > core_sm_sob_n_f;
    bool core_sm_aregd_load;
    bool core_sm_dregi_load;
    bool core_sm_drego_load;
    bool core_sm_sreg_load;
    bool core_sm_xreg_load;
    bool core_sm_yreg_load;
    bool core_sm_lreg_load;
    bool core_sm_jregi_load;
    bool core_sm_jrego_load;
    bool core_sm_kregi_load;
    sc_core::sc_signal< bool > core_sm_z_flag_f;
    sc_core::sc_signal< bool > core_sm_branch_carry_f;
    bool core_sm_adh_alu;
    bool core_sm_adh_dreg;
    bool core_sm_adh_zpg;
    bool core_sm_adh_onepg;
    uint8_t core_sm_domux_001;
    uint8_t core_sm_domux_010;
    uint8_t core_sm_domux_011;
    uint8_t core_sm_domux_100;
    uint8_t core_sm_domux_101;
    uint8_t core_sm_domux_110;
    uint8_t core_sm_domux_111;
    sc_core::sc_signal< bool > core_sm_resetl;
    bool core_sm_interrupt;
    sc_core::sc_signal< bool > core_sm_reset_proc;
    sc_core::sc_signal< bool > core_sm_nmi_proc;
    sc_core::sc_signal< bool > core_sm_irq_proc;
    sc_core::sc_signal< bool > core_sm_irq;
    bool core_sm_irq_pend;
    sc_core::sc_signal< bool > core_sm_nmi_pend;
    sc_core::sc_signal< bool > core_sm_nmi1;
    sc_core::sc_signal< bool > core_sm_nmi2;
    sc_core::sc_signal< bool > core_sm_addr_carry;
    bool core_sm_imp2psr;
    bool core_sm_imp2tx;
    bool core_sm_imp2inc;
    bool core_sm_imm_1_addr;
    bool core_sm_rel_addr;
    bool core_sm_zpg_1_addr;
    bool core_sm_zpx_1_addr;
    bool core_sm_abs_1_addr;
    bool core_sm_abx_1_addr;
    bool core_sm_aby_1_addr;
    bool core_sm_inx_1_addr;
    bool core_sm_iny_1_addr;
    bool core_sm_ind_1_addr;
    bool core_sm_imm_3_addr;
    bool core_sm_zpg_3_addr;
    bool core_sm_zpx_3_addr;
    bool core_sm_abs_3_addr;
    bool core_sm_abx_3_addr;
    bool core_sm_acc_addr;
    bool core_sm_zpg_rmw_addr;
    bool core_sm_zpx_rmw_addr;
    bool core_sm_abs_rmw_addr;
    bool core_sm_abx_rmw_addr;
    bool core_sm_type1_read;
    sc_core::sc_signal< bool > core_sm_type1_calc;
    bool core_sm_type2_read;
    sc_core::sc_signal< bool > core_sm_type2_calc;
    sc_core::sc_signal< bool > core_sm_type2_write;
    sc_core::sc_signal< bool > core_sm_type2_done;
    bool core_sm_type3_read;
    sc_core::sc_signal< bool > core_sm_type3_calc;
    bool core_sm_branch_take;
    bool core_sm_adc_op;
    bool core_sm_lda_op;
    bool core_sm_cmp_op;
    bool core_sm_cpx_op;
    bool core_sm_cpy_op;
    bool core_sm_ora_op;
    bool core_sm_and_op;
    bool core_sm_eor_op;
    bool core_sm_sbc_op;
    bool core_sm_asl_op;
    bool core_sm_lsr_op;
    bool core_sm_rol_op;
    bool core_sm_ror_op;
    bool core_sm_inc_op;
    bool core_sm_dec_op;
    bool core_sm_ldx_op;
    bool core_sm_ldy_op;
    bool core_sm_stx_op;
    bool core_sm_sty_op;
    bool core_sm_bit_op;
    bool core_sm_rmb_op;
    bool core_sm_smb_op;
    bool core_sm_bbx_op;
    bool core_sm_trb_op;
    bool core_sm_tsb_op;
    uint16_t core_sm_alu_ctl_d;
    uint8_t core_sm_alu_ctl_bsel;
    bool core_sm_alu_ctl_carry;
    bool core_sm_alu_ctl_bcd;
    uint8_t core_sm_alu_ctl_mode;
    bool core_sm_log_b_inv;
    sc_core::sc_signal< uint8_t > core_sm_opcd_ido;
    sc_core::sc_signal< uint8_t > core_sm_st_ido;

    void hif_cone_core_addrh();


    void hif_cone_core_addrl();


    void hif_cone_core_alu2op();


    void hif_cone_core_alu_jrg_idi();


    void hif_cone_core_alu_jrg_ld();


    void hif_cone_core_alu_ld();


    void hif_cone_core_alu_outl();


    void hif_cone_core_aregl();


    void hif_cone_core_domux_sel();


    void hif_cone_core_drg_idi();


    void hif_cone_core_drg_ld();


    void hif_cone_core_pc_cntih();


    void hif_cone_core_pc_cntil();


    void hif_cone_core_pc_ctl();


    void hif_cone_core_pc_hreg_in();


    void hif_cone_core_pchl();


    void hif_cone_core_pcll();


    void hif_cone_core_psrl();


    void hif_cone_core_reset();


    void hif_cone_core_rg_load();


    void hif_cone_core_sm_abx_1_addr();


    void hif_cone_core_sm_abx_3_addr();


    void hif_cone_core_sm_abx_rmw_addr();


    void hif_cone_core_sm_aby_1_addr();


    void hif_cone_core_sm_adc_op();


    void hif_cone_core_sm_alu_ctl_d();


    void hif_cone_core_sm_and_op();


    void hif_cone_core_sm_asl_op();


    void hif_cone_core_sm_bit_op();


    void hif_cone_core_sm_cmp_op();


    void hif_cone_core_sm_cpx_op();


    void hif_cone_core_sm_cpy_op();


    void hif_cone_core_sm_dec_op();


    void hif_cone_core_sm_eor_op();


    void hif_cone_core_sm_imp2inc();


    void hif_cone_core_sm_imp2tx();


    void hif_cone_core_sm_inc_op();


    void hif_cone_core_sm_interrupt();


    void hif_cone_core_sm_iny_1_addr();


    void hif_cone_core_sm_irq_pend();


    void hif_cone_core_sm_lda_op();


    void hif_cone_core_sm_ldx_op();


    void hif_cone_core_sm_ldy_op();


    void hif_cone_core_sm_lsr_op();


    void hif_cone_core_sm_opcode();


    void hif_cone_core_sm_opcode_in();


    void hif_cone_core_sm_opcode_ld();


    void hif_cone_core_sm_ora_op();


    void hif_cone_core_sm_rol_op();


    void hif_cone_core_sm_ror_op();


    void hif_cone_core_sm_sbc_op();


    void hif_cone_core_sm_state();


    void hif_cone_core_sm_state_in();


    void hif_cone_core_sm_syncl();


    void hif_cone_core_sm_trb_op();


    void hif_cone_core_sm_tsb_op();


    void hif_cone_core_sm_type1_read();


    void hif_cone_core_sm_type2_read();


    void hif_cone_core_sm_type3_read();


    void hif_cone_core_sm_we_d_n();


    void hif_cone_core_sreg_cen();


    void hif_cone_core_sreg_up();


    void hif_cone_core_sregl();


    void hif_cone_core_xregl();


    void hif_cone_core_yregl();


    void hif_cone_oen();


    void hif_cone_vpa();


    void hif_cone_we_n_out_sig();



    SC_HAS_PROCESS( m6502 );

    m6502( sc_core::sc_module_name name_ );
    ~m6502();


private:

    m6502( const m6502 & );
    const m6502& operator= ( const m6502 & );


    void core_arg_ff1();
    void core_xrg_ff1();
    void core_yrg_ff1();
    void core_pc_counter();
    void core_drg_ff1();
    void core_srg_process_0();
    void core_adlmx_lrg_ff1();
    void core_alu_krg_ff1();
    void core_alu_jrg_ff1();
    void core_sm_elr();
    void core_sm_misc();
    void core_sm_pipe();
    void core_sm_opcd_ff1();
    void core_sm_st_ff1();
    void core_domx_process();
    void globact_process();
    void globact_process_0();
    void globact_process_1();
    void globact_process_2();
    void globact_process_3();
    void we_n_update_process();
    void globact_process_4();

};


#endif

